KuhnDiscoverXL60 = {};

function KuhnDiscoverXL60.prerequisitesPresent(specializations)
	return true;
end;

function KuhnDiscoverXL60:load(xmlFile)


	self.setParticleState = SpecializationUtil.callSpecializationsFunction("setParticleState");
	
	  
	self.particleSystems = {};
	local particleSystemCount = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.ParticleSystems#count"), 0);
	for i = 1, particleSystemCount do
		local namei = string.format("vehicle.ParticleSystems.ParticleSystem%d", i);
		self.particleSystems[i] = {};
		self.particleSystems[i].ps = {};
		self.particleSystems[i].node = {};
		self.particleSystems[i].rain = {};
		self.particleSystems[i].node = Utils.indexToObject(self.components, getXMLString(xmlFile, namei .. "#node"));
		self.particleSystems[i].rain = Utils.getNoNil(getXMLBool(xmlFile, namei .. "#deactivateOnRain"), false);
		Utils.loadParticleSystem(xmlFile, self.particleSystems[i].ps, namei, self.components, false, nil, self.baseDirectory);
	end;
	self.particleState = false;
	
	
end

function KuhnDiscoverXL60:delete()
	for k, v in pairs(self.particleSystems) do
		Utils.deleteParticleSystem(v.ps);
	end;
end;


function KuhnDiscoverXL60:update(dt)
	
	if self.animationParts[1].clipEndTime then
		if self.animationParts[2].currentPosition > 1100 then
			if self.lastSpeed * 3600 > 3 then
				self:setSoundState(self:getIsActiveForSound());
			else
				self:setSoundState(false);
				self:setParticleState(false);
			end;
			
					if area > 2 then
						if self.lastSpeed * 3600 > 8 then
							self:setParticleState(true);
						else
							self:setParticleState(false);
						end;
					else
						self:setParticleState(false);
					end;
				end;
			end;
		else			
			self:setParticleState(false);
		end;
	else

		self:setParticleState(false);
	end;
end;


function KuhnDiscoverXL60:setParticleState(state, noEventSend)
	SetParticleState.sendEvent(self, state, noEventSend);
	for k, v in pairs(self.particleSystems) do
		if v.rain then
			if g_currentMission.environment.lastRainScale <= 0.1 and g_currentMission.environment.timeSinceLastRain > 40 then
				Utils.setEmittingState(v.ps, state);
			else
				Utils.setEmittingState(v.ps, false);
			end;
		else
			Utils.setEmittingState(v.ps, state);
		end;
	end;
	self.particleState = state;
end;




